var app = {
    init: function() {
        // app.bind_events();
        app.init_jpush();
        if(localStorage.getItem("server")) {
            app.setup_login_own();
        } else {
            localStorage.server = "https://dyslndx.dongying.gov.cn"
            // localStorage.server = "http://192.168.199.245:8001"
            app.setup_login_own();
        }
        common.handle_external_links();
    },
    setup_login_own: function() {
        if(localStorage.server && localStorage.session_id) {
            app.if_session_valid(app.start_desk, app.guest_login);
        } else {
            app.guest_login();
        }
    },
    init_jpush: function(){
        //启用极光推送服务
        if ('JPush' in window) {
            try {
                window.JPush.init();
                window.JPush.setDebugMode(true);
                if (device.platform != "Android") {
                    window.JPush.setApplicationIconBadgeNumber(0);
                }
            } catch (exception) {
            }
        } else {
        }
    },
    bind_events: function() {
		// app.bind_select_server();
        app.bind_login();
        app.bind_login_guest();
		app.bind_otp_verification();
		// app.bind_change_server();

        app.show_signup();
        app.show_login_1();
        app.bind_signup();
    },
    guest_login: function(){
        let argdata = {};
        if (localStorage.user && localStorage.pwd){
            argdata = {
                usr: localStorage.user,
                pwd: localStorage.pwd,
                device: "mobile"
            }
        } else {
            argdata = {
                device: "mobile",
                guest: "guest"
            }
        }
        $.ajax({
            method: "POST",
            url: localStorage.server + "/api/method/login",
            data: argdata
        }).success(function(data, status, xhr) {
            if(data && data['message']=='Logged In') {
                localStorage.user = $("#usr").val();
                // localStorage.pwd = $("#pwd").val();
                var cookie_source = xhr.getResponseHeader('Set-Cookie');
                localStorage.session_id = common.get_cookie("sid", cookie_source);
                app.start_desk();
            } else if(data && data["verification"]) {
                app.show_otp(data);
            }
        }).error(function(ee) {
            common.msgprint(ee);
            common.msgprint(JSON.stringify(ee));
            common.msgprint("系统正忙，稍后再试。");
        }).always(function() {
            // $("#usr").val("");
            // $("#pwd").val("");
        });
            return false;
    },
    bind_login_guest: function() {
        $(".btn-login-guest").on("click", function() {
            $me = $(this);
            $me.prop("disabled", true);
            $.ajax({
                method: "POST",
                url: localStorage.server + "/api/method/login",
                data: {
                    device: "mobile",
                    guest: "guest"
                }
            }).success(function(data, status, xhr) {
                if(data && data['message']=='Logged In') {
                    localStorage.user = $("#usr").val();
                    var cookie_source = xhr.getResponseHeader('Set-Cookie');
                    localStorage.session_id = common.get_cookie("sid", cookie_source);
                    app.start_desk();
                } else if(data && data["verification"]) {
                    app.show_otp(data);
                }
            }).error(function(ee) {
                // common.msgprint(ee);
                // common.msgprint(JSON.stringify(ee));
                common.msgprint("系统正忙，稍后再试。");
                $me.prop("disabled", false);
            }).always(function() {
                // $("#usr").val("");
                // $("#pwd").val("");
            });
            return false;
        });
    },
    bind_login: function() {
        $(".btn-login").on("click", function() {
            $me = $(this);
            $me.prop("disabled", true);
            $.ajax({
                method: "POST",
                url: localStorage.server + "/api/method/login",
                data: {
                    usr: $("#usr").val(),
                    pwd: $("#pwd").val(),
                    device: "mobile"
                }
            }).success(function(data, status, xhr) {
                if(data && data['message']=='Logged In') {
                    localStorage.user = $("#usr").val();
                    localStorage.pwd = $("#pwd").val();
                    var cookie_source = xhr.getResponseHeader('Set-Cookie');
                    localStorage.session_id = common.get_cookie("sid", cookie_source);
                    app.start_desk();
                } else if(data && data["verification"]) {
                    app.show_otp(data);
                }
            }).error(function(ee) {
                common.msgprint("登陆失败，请检查登陆信息。");
                $me.prop("disabled", false);
            }).always(function() {
                // $("#usr").val("");
                // $("#pwd").val("");
            });
            return false;
        });
    },
	bind_otp_verification: function() {
		$(".btn-verify").on("click", function() {

			$me = $(this);
			$me.prop("disabled", true);
			$.ajax({
				method: "POST",
				url: localStorage.server + "/api/method/login",
				data: {
					cmd: "login",
					otp: $("#otp").val(),
					tmp_id: localStorage.tmp_id,
					device: "mobile"
				}
			}).success(function(data, status, xhr) {
				localStorage.user = $("#usr").val();
				var cookie_source = xhr.getResponseHeader('Set-Cookie');
				localStorage.session_id = common.get_cookie("sid", cookie_source);
				app.start_desk();
			}).error(function() {
				common.msgprint("验证码有误");
				$me.prop("disabled", false);
			});

			return false;
		});
	},
	bind_select_server: function() {
        $(".btn-select-server").on("click", function() {
            // check if erpnext / frappe server
            $(this).prop("disabled", true);

            var server = $("#server").val();
            if(!server) {
                app.retry_server();
                return false;
            }

            if(server.substr(0, 7)!== "http://" && server.substr(0, 8)!== "https://") {
                // http / https not provided
                // try https
                app.verify_server("https://" + server, select,
                    function() {
                        // try http
                        app.verify_server("http://" + server, select, app.retry_server);
                    }
                );
            } else {
                app.verify_server(server, select, app.retry_server);
            }

            return false;
        });
		$(".recent-server-list").on("click", "a", function() {
			$this = $(this);
			$this.prop("disabled", true);
			app.verify_server($this.text(), select, app.retry_server);
		});

		function select(server) {
			localStorage.server = app.strip_trailing_slash(server);
			app.save_server_in_recent(localStorage.server);
			app.setup_login();
		}
	},
    verify_server: function(server, valid, invalid) {
        $.ajax({
    			method: "GET",
    			url: server + "/api/method/version",
    		})
            .success(function(data) {
                if(data.message) {
                    valid(server);
                } else {
                    invalid();
                };
            })
            .fail(function() { invalid() })
            .error(function() { invalid() });
    },
	bind_change_server: function() {
		$(".change-server").on("click", function() {
			localStorage.server = "";
			app.show_server(true);
			return false;
		});
	},
    strip_trailing_slash: function(server) {
        return server.replace(/(http[s]?:\/\/[^\/]*)(.*)/, "$1");
    },
	save_server_in_recent: function(server) {
		server = server.toLowerCase().trim();

		var recent_servers = localStorage.recent_servers ?
			JSON.parse(localStorage.recent_servers) : [];

		var index = recent_servers.indexOf(server);
		if(index !== -1) {
			recent_servers.splice(index, 1);
		}
		recent_servers.push(server);

		localStorage.setItem("recent_servers", JSON.stringify(recent_servers));
	},
    setup_login: function() {
		if(localStorage.server && localStorage.session_id) {
			app.if_session_valid(app.start_desk, app.show_login);
		} else {
			app.show_login();
		}
    },
	show_login: function() {
		$(".app").removeClass("hide");
        $(".div-select-server").addClass("hide");
        $(".div-signup").addClass("hide");
        $(".div-login").removeClass("hide");
		$(".current-server").text(localStorage.server);
	},
	show_otp: function(data) {
		$(".div-login").addClass("hide");
		$(".div-otp").removeClass("hide");
		localStorage.tmp_id = data["tmp_id"];
	},
	if_session_valid: function(if_yes, if_no) {
		app.set_sid_cookie();
		$.ajax({
			method: "GET",
			crossDomain: true,
			url: localStorage.server + "/api/method/ping",
		}).success(function(data) {
			if(data.message === "pong") {
				if_yes();
			} else {
				if_no();
			}
		}).error(function() {
			if_no();
		});
	},
	set_sid_cookie: function() {
		document.cookie = "sid=" + localStorage.session_id +
			"; expires=Fri, 31 Dec 9999 23:59:59 GMT";
	},
	start_desk: function() {
		window.location.href = "desk.html";
	},
    retry_server: function() {
        // common.msgprint("服务器地址不可用，请重新输入。");
		// app.show_server();
        common.msgprint("服务器正在维护中，请稍后登陆。");
        localStorage.server = "http://dyslndx.dongying.gov.cn"
        app.show_login();
    },
	show_server: function(clear) {
		$(".app").removeClass("hide");
        $(".btn-select-server").prop("disabled", false);
        $(".div-select-server").removeClass("hide");
        if(clear) {
            $(".div-login").addClass("hide");
        }
        $(".div-signup").addClass("hide");
		app.show_recent_servers();
	},
	show_recent_servers: function() {
		if(localStorage.recent_servers) {
			var recent_servers = JSON.parse(localStorage.recent_servers);
			recent_servers.reverse().splice(2);

			var html = "<li class='text-muted'>Recent:</li>"
			$.each(recent_servers, function(i, server) {
				html += '<li><a>'+server+'</a></li>';
			});
			$('.recent-server-list').empty().append(html).removeClass('hide');
		}
	},

    /*!
     * Added function: 
            bind_signup 注册事件
            show_signup 显示注册框
            show_login_1 显示登陆框
        by ws 
    */
    bind_signup: function() {
        $(".btn-signup").on("click", function() {
            $me = $(this);
            var sign_data = {}
            var phoneReg = /(^1[3|4|5|6|7|8|9]\d{9}$)|(^09\d{8}$)/;
            sign_data["mobile_no"] = ($("#mobile_no").val() || "").trim();
            if (!phoneReg.test(sign_data["mobile_no"])) {
                common.msgprint(" 请输入有效的手机号码");
                return false;
            }
            var id_card = ($("#id_card").val() || "").trim();
            var idc2= /^[1-9][0-9]{5}([1][9][0-9]{2}|[2][0][0|1][0-9])([0][1-9]|[1][0|1|2])([0][1-9]|[1|2][0-9]|[3][0|1])[0-9]{3}([0-9]|[X])$/;
            if (id_card != "" && !idc2.test(id_card)) {
                common.msgprint(" 身份证号格式不正确。");
                return false;
            }

            sign_data["id_card"] = id_card;
            birth_date=(id_card.substring(6,10)).toString()+"-"+(id_card.substring(10,12)).toString()+"-"+(id_card.substring(12,14)).toString()
            sign_data["birth_date"] = birth_date;
            if(id_card.substring(16,17)%2==0){
                sign_data["gender"] = '女';
            }else{
                sign_data["gender"] = '男';
            }

            var email = ($("#signup_email").val() || "").trim();
            var pa2=/^[a-z]([a-zA-Z0-9_]{5,20})@([a-z0-9]{1,10})([.]{1})([a-z]{2,4})$/;
            if (email != "" && !pa2.test(email)) {
                common.msgprint(" 邮箱格式不正确。");
                return false;
            }
            sign_data["email"] = email ? email : sign_data["mobile_no"] + "@example.com";
            if ($("#signup_password").val()==$("#sign_password").val()){
                sign_data["pwd"] = $("#signup_password").val();
            }else{                
                common.msgprint("两次密码不一致！");
                return false;
            }
            sign_data["redirect_to"] = '';
            sign_data["full_name"] = ($("#signup_fullname").val() || "").trim();
            if (!sign_data.full_name||!sign_data.mobile_no||!sign_data.pwd||!sign_data.id_card){
                common.msgprint("姓名、手机号、身份证号、密码必填！");
                return false;
            }
            $me.prop("disabled", true);
            $.ajax({
                method: "POST",
                url: localStorage.server + "/api/method/frappe.core.doctype.user.user.sign_up",
                data: sign_data
            }).success(function(data, status, xhr) {
                var res = data["message"];
                if(res[0] == 0){
                    if("Registered but disabled" != res[1]){
                        common.msgprint("账号已被注册，但不可用，请联系管理员！");
                    } else {
                        common.msgprint(res[1]);
                    }
                }else if(res[0] == 1){
                    common.msgprint("验证码有误");
                }else if(res[0] == 2){
                    common.msgprint("注册完成");
                    $("#signup_fullname").val("");
                    $("#mobile_no").val("");
                    $("#id_card").val("");
                    $("#signup_email").val("");
                    $("#sign_password").val("");
                    $("#signup_password").val("");
                    // getRegistrationID();
                    app.show_login();
                }
                $me.prop("disabled", false);
            }).error(function() {
                // common.msgprint("Invalid Login");
                common.msgprint("注册失败，请稍后再试");
                $me.prop("disabled", false);
            }).always(function() {
                // $("#usr").val("");
                // $("#pwd").val("");
            });
            return false;
        });
    },
    show_signup: function() {
        $(".show_signup").on("click", function() {
            $(".app").removeClass("hide");
            $(".div-select-server").addClass("hide");
            $(".div-login").addClass("hide");
            $(".div-signup").removeClass("hide");
            $(".current-server").text(localStorage.server);
        });
    },
    show_login_1: function() {
        $(".show_login").on("click", function() {
            $(".app").removeClass("hide");
            $(".div-select-server").addClass("hide");
            $(".div-signup").addClass("hide");
            $(".div-login").removeClass("hide");
            $(".current-server").text(localStorage.server);
        });
    }
};

document.addEventListener('deviceready', app.init, false);
document.addEventListener("offline", function(){ // 断网
    networkFlag = false;
    // 其它语句
}, false);
document.addEventListener("online", function(){  // 开启网络
    networkFlag = true;
    // 其它语句
}, false);